package app

import (
	"context"
	"gim/internal/business/domain/user/service"
)

type authApp struct{}

var AuthApp = new(authApp)

// SignIn 长连接登录
func (*authApp) SignIn(ctx context.Context, phoneNumber, code string, masterId, deviceId int64, pushAlia, nickname, avatarUrl string) (bool, int64, string, int64, error) {
	return service.AuthService.SignIn(ctx, phoneNumber, code, masterId, deviceId, pushAlia, nickname, avatarUrl)
}

// Auth 验证用户是否登录
func (*authApp) Auth(ctx context.Context, userId, deviceId int64, token string) error {
	return service.AuthService.Auth(ctx, userId, deviceId, token)
}

// AuthMaster 验证站长权限
func (*authApp) AuthMaster(ctx context.Context, masterId string) error {
	return service.AuthService.AuthMaster(ctx, masterId)
}
